function [output] = trackingFilter(numSegs,unfilteredData,fs,fStart,fEnd,stDelay,enDelay)
%window tracking filter
% take a data vector that was generated by a chirp function and filter it
% by dividing it into segments and applying a bandpass filter to each
% segment, then applying a window to each segment to eliminate out-of-band
% noise.

%   Input:
%   numSegs = number of segments to divide the chirp into
%   unfilteredData = time series data to be processed
%   fs = sample frequency in Hz
%   fStart = start frequency of chirp
%   fEnd = end frequency of chirp
%   stDelay = delay before chirp starts in seconds
%   enDelay = delay after chirp ends in seconds

%   Output:
%   output = processed data

%% Start program
disp('Tracking Filter being applied');
N = length(unfilteredData);
timeVec = linspace(0,N/fs,N)';
%dt = 1/fs;

%% create frequency vector
fRatio = fEnd/fStart;

chStTime = stDelay;
chEnTime = (N/fs) - stDelay;
chDur = chEnTime - chStTime;

%% apply filters

% determine the start time of each segment
filterStTime = linspace(chStTime,chEnTime,numSegs+1);
filterStTime = round(filterStTime .* fs) ./ fs; % round to nearest sample

filterEdge = fStart .* fRatio.^((filterStTime-chStTime)./chDur);
%for idxCnt = 1:length(filterStTime)
%    a = find(abs(chirpVec - filterStTime(1)) < 0.0001);
%end
%chirpVec(filterStTime,1);

% divide unfiltered data vector into many unfiltered data vectors
%for segCnt = 1:numSegs
%    data(:,numSegs) = unfilteredData(:,1);
%end

%% Filter Loop
% preallocate
filteredDataSets = zeros(N,numSegs);

filterOrder = 500;
Apass = 1; %passband ripple
for filterCnt = 1:numSegs
    Fmin = filterEdge(filterCnt);
    Fmax = filterEdge(filterCnt+1);
    win = nuttallwin(filterOrder+1);
    %Fc = freqStep(filterCnt);
%    h = fdesign.bandpass('N,Fp1,Fp2,Ap', filterOrder, Fmin, Fmax, Apass, fs);
    h = fir1(filterOrder, [Fmin Fmax]/(fs/2), 'bandpass', win, 'scale');
    %Hd = design(h, 'cheby1');
    Hd = dfilt.dffir(h);
    filteredDataSets(:,filterCnt) = filter(Hd,unfilteredData(:,1));
%    figure;
%plot(timeVec,filteredDataSets(:,filterCnt));
end

%% Window the active data
[~,ROV] = winGen('HFT70',10); % get ROV of chosen window
segIdx = filterStTime * fs;
segLen = (segIdx(2)-segIdx(1)); % length of filtered data segment
winLen = segLen * (1 + ROV.*0.01); % length of window = segLen + ROV
disp(['Window size: ',num2str(winLen)]);

[window,~] = winGen('HFT70',winLen); % get window

windowedDataSets = zeros(size(filteredDataSets));
for segCnt = 1:numSegs
    windowedDataSets(segIdx(segCnt):segIdx(segCnt)+winLen-1,segCnt) =...
        filteredDataSets(segIdx(segCnt):segIdx(segCnt)+winLen-1,segCnt).*...
        window;
end
disp(['Number of windows applied: ',num2str(numSegs)]);
output = sum(windowedDataSets,2);
disp('Tracking Filter Complete');
